package minica;

import org.eclipse.jface.action.CoolBarManager;
import org.eclipse.jface.action.ICoolBarManager;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * The ApplicationActionBarAdvisor Class from RCP.
 * Fills CoolBar, MenuBar...
 * @author ???
 *
 */
public class ApplicationActionBarAdvisor extends ActionBarAdvisor {

	private IWorkbenchAction	iExitAction;

	private IWorkbenchAction	iAboutAction;

	private IWorkbenchAction	iNewWindowAction;

	public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
		super(configurer);
	}

	@Override
	protected void fillCoolBar(ICoolBarManager coolBar) {
		CoolBarManager coolbar = new CoolBarManager();
		coolbar.add(new Separator(IWorkbenchActionConstants.MB_ADDITIONS));
	}

	protected void fillMenuBar(IMenuManager menuBar) {

		MenuManager fileMenu = new MenuManager("&File", IWorkbenchActionConstants.M_FILE);
		fileMenu.add(iExitAction);

		MenuManager CAMenu = new MenuManager("C&A", "camenu");
		//CAMenu.add(new Separator(IWorkbenchActionConstants.MB_ADDITIONS));

		MenuManager CertificateMenu = new MenuManager("&Certificate");

		MenuManager RevocationMenu = new MenuManager("&Revocation");

		MenuManager SettingsMenu = new MenuManager("&Settings");

		MenuManager helpMenu = new MenuManager("&Help", IWorkbenchActionConstants.M_HELP);
		helpMenu.add(iAboutAction);

		menuBar.add(fileMenu);
		menuBar.add(CAMenu);
		menuBar.add(CertificateMenu);
		menuBar.add(RevocationMenu);
		menuBar.add(SettingsMenu);
		menuBar.add(helpMenu);
	}

	protected void makeActions(IWorkbenchWindow window) {

		iExitAction = ActionFactory.QUIT.create(window);
		register(iExitAction);

		iAboutAction = ActionFactory.ABOUT.create(window);
		register(iAboutAction);

		iNewWindowAction = ActionFactory.OPEN_NEW_WINDOW.create(window);
		register(iNewWindowAction);

	}

}
