package minica.crypto;

import java.security.GeneralSecurityException;
import java.security.KeyPair;

import javax.swing.event.ChangeListener;

import codec.x509.X509Certificate;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * The Base Interface for all Certificates.
 * @author tarzan
 *
 */
public interface ICertificate {

	public void addChangeListener(ChangeListener l);

	/**
	 * Return the embedded X509 Certificate.
	 * @return
	 */
	public X509Certificate getCertificate();

	/**
	 * Get the associated Key pair.
	 * TODO pkcs 12 lesen
	 * TODO speicherort ablegen
	 * @return
	 */
	public KeyPair getKeyPair(String password) throws GeneralSecurityException;

	/**
	 * Get the parent certificate.
	 * May be null if this is a root certificate.
	 * @return
	 */
	public ICertificate getParent();

	public void removeChangeListener(ChangeListener l);

	/**
	 * Set the associated key pair.
	 * TODO pkcs 12 schreiben
	 * @param kp
	 */
	public void setKeyPair(KeyPair kp, String password);

	public void setKeyPair(KeyPair kp, String password, boolean exportAlternates);

}
