package minica.crypto;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.progress.UIJob;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * The model change listener.
 * @author tex
 *
 */
public class ModelChangeListener implements IModelChangeListener {

	TreeViewer	treeviewer;

	public ModelChangeListener(TreeViewer treeview) {
		treeviewer = treeview;
	}

	/* (non-Javadoc)
	 * @see minica.crypto.IModelChangeListener#refresh()
	 */
	public void refresh() {
		UIJob uijob = new UIJob("Refreshing Tree") {
			@Override
			public IStatus runInUIThread(IProgressMonitor monitor) {
				//System.out.println("ModelChangeListener.refresh() - Refreshing tree!");
				treeviewer.refresh();
				return Status.OK_STATUS;
			}
		};
		uijob.schedule();
	}
}
