package minica.editors;

import minica.crypto.ICertificate;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import codec.x509.X509Certificate;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * This is the input Class for the CertificateMultiPageEditor.
 * It is needed during creation of a CertificateMultiPageEdior.
 * @author stephan
 *
 */
public class CertificateMultiPageEditorInput implements IEditorInput {

	private String			name;

	private X509Certificate	cert;

	private ICertificate	icert;

	public CertificateMultiPageEditorInput(ICertificate selection) {

		super();
		this.name = selection.getCertificate().getSubjectDN() + " ("
				+ selection.getCertificate().getSerialNumber().toString() + ")";
		this.icert = selection;
		this.cert = (X509Certificate) icert.getCertificate();
	}

	public CertificateMultiPageEditorInput(String name) {
		super();
		this.name = name;
		//System.out.println("Input created: " + name);
	}

	public boolean exists() {
		//not important
		return false;
	}

	@SuppressWarnings("unchecked")
	public Object getAdapter(Class adapter) {
		// not important
		return null;
	}

	public X509Certificate getCertificate() {
		return this.cert;
	}

	public ICertificate getICertificate() {
		return this.icert;
	}

	public ImageDescriptor getImageDescriptor() {
		// not important
		return null;
	}

	public String getName() {
		return name;
	}

	public IPersistableElement getPersistable() {
		// not important
		return null;
	}

	public String getToolTipText() {
		// do nothing
		return name;
	}

}
