package minica.util;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import codec.asn1.ASN1Integer;
import codec.x509.CRLEntry;
import codec.x509.X509Crl;
import codec.x509.X509Extension;
/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of MiniCA.
 * 
 * MiniCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * MiniCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with MiniCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * This is a CRL helper class.
 * @author stephan
 */
public class CRLHelper {

	private List<CRLEntry>	crlentries;

	private BigInteger		serial;

	@SuppressWarnings("unchecked")
	public CRLHelper(X509Crl crl) {

		if ((crl != null) && (crl.getRevokedCertificates() != null)) {
			this.crlentries = new ArrayList<CRLEntry>(crl.getRevokedCertificates());
			Collection<X509Extension> extensions = crl.getExtensions();
			for (X509Extension extension : extensions) {
				if (extension.getOID().toString().equals("2.5.29.20")) {
					serial = ((ASN1Integer) extension.getValue()).getBigInteger();
					//System.out.println(serial.toString());
				}

			}
		}
		//byte[] serial = crl.getExtensionValue("2.5.29.20");

	}

	public ArrayList<BigInteger> getCRLEntrySerials() {
		ArrayList<BigInteger> serials = new ArrayList<BigInteger>();
		if (crlentries != null) {

			for (CRLEntry current : crlentries) {
				serials.add(current.getSerialNumber());
			}
		}

		return serials;
	}

	public BigInteger getSerial() {
		return serial;
	}

}
