package minica.util;
/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of MiniCA.
 * 
 * MiniCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * MiniCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with MiniCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * A String helper class.
 * @author dominik
 * Note: This code was written by Dominik Schulz and previously used in several projects as well as being published.
 */
public class StringTools {
	/**
	 * 
	 * @param string - The String that will be broken up into lines of n chars
	 * @param breakAfter - The max. number of chars per line
	 * @return the broken string
	 */
	public static String lineBreakAfterNchars(String text, int breakAfter) {
		breakAfter--;
		int startMark = 0;
		int endMark = breakAfter;
		String lines = "";
		for (int i = 0; i < text.length(); i++) {
			if (i % breakAfter == 0) {
				if ((text.length() - endMark) < 0) {
					endMark = text.length();
					lines += text.substring(startMark, endMark);
				} else {
					lines += text.substring(startMark, endMark) + "\n";
				}
				startMark = endMark;
				endMark = endMark + breakAfter;
			}
		}
		return lines;
	}
}
