package minica.util;

import java.util.List;

import org.jdom.Element;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * a xml utility class
 * @author dominik
 *
 */
public class XMLHelper {
	/**
	 * Descend into the XML-Tree and find a node
	 * with the given name
	 * @param nodes
	 * @param name
	 * @return null if nothing found, else the element
	 */
	@SuppressWarnings("unchecked")
	public static Element getXMLNodeByName(List nodes, String name) {
		for (int i = 0; i < nodes.size(); i++) {
			Element element = (Element) nodes.get(i);
			if (element == null) {
				continue;
			}
			if (!element.getName().equals(name)) {
				// descend further
				Element returned = getXMLNodeByName(element.getChildren(), name);
				if (returned != null) {
					return returned; // wenn wir was gefunden haben wird hier abgebrochen
				}
				continue;
			}
			return element;
		}
		return null;
	}

}
