package test;

import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.Signature;
import java.security.SignatureException;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import junit.framework.TestCase;
import minica.crypto.CryptoInformationProvider;

/*
 * Copyright (c) 2007-2008 Bastian Neuburger Copyright (c) 2007-2008 Dominik Schulz Copyright (c) 2007-2008 Stephan
 * Heuser Copyright (c) 2007-2008 Sören Mess
 * 
 * This file is part of FlexiCA.
 * 
 * FlexiCA is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * 
 * FlexiCA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with FlexiCA; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA </pre>
 */
/**
 * TODO description
 * @author dominik
 */
public class CryptoInformationProviderTest extends TestCase {

	private CryptoInformationProvider	cip;

	public void testAddValidAsymmKeySize() {
		cip.addValidAsymmKeySize("Test", 1);
		Set<Integer> ks = cip.getValidKeySizesForAsym("Test");
		assertEquals(true, ks.contains(1));
	}

	public void testAddValidDigestAlgorithm() {
		cip.addValidDigestAlgorithm("Test");
		Set<String> d = cip.getValidDigestAlgorithms();
		assertEquals(true, d.contains("Test"));
	}

	public void testAddValidSignatureAlgorithm() {
		fail("Not yet implemented");
	}

	public void testAddValidSymmKeySize() {
		fail("Not yet implemented");
	}

	public void testGetValidAsymmetricAlgorithms() {
		fail("Not yet implemented");
	}

	public void testGetValidDigestAlgorithms() {
		fail("Not yet implemented");
	}

	public void testGetValidKeySizesForAsym() {
		fail("Not yet implemented");
	}

	public void testGetValidKeySizesForSymm() {
		fail("Not yet implemented");
	}

	public void testGetValidSignatureAlgorithms() {
		fail("Not yet implemented");
	}

	public void testGetValidSignatureAlgorithmsFor() {
		Map<String, Set<Integer>> m = cip.getValidAsymmetricAlgorithms();
		System.out.println(m.size());
		// TODO handle concurrent modification exception
		for (Iterator<String> iterator = m.keySet().iterator(); iterator.hasNext();) {
			String algo = (String) iterator.next();
			Set<Integer> sizes = m.get(algo);
			KeyPairGenerator kpg;
			try {
				kpg = KeyPairGenerator.getInstance(algo);
				int keysize = sizes.iterator().next();
				kpg.initialize(keysize);
				KeyPair kp = kpg.generateKeyPair();
				try {
					String signAlgo = "MD5withRSA";
					Signature s = Signature.getInstance(signAlgo);
					s.initSign(kp.getPrivate());
					s.update("Test".getBytes());
					s.sign();
					System.out.println("Combination ok: " + algo + ", " + keysize + ", " + signAlgo);
				} catch (NoSuchAlgorithmException e) {
					assertFalse(true);
				} catch (InvalidKeyException e) {
					assertFalse(true);
				} catch (SignatureException e) {
					assertFalse(true);
				}
			} catch (NoSuchAlgorithmException e) {
				assertFalse(true);
			}
		}
	}

	public void testGetValidSymmetricAlgorithms() {
		fail("Not yet implemented");
	}

	public void testSaveDb() {
		fail("Not yet implemented");
	}

	protected void setUp() throws Exception {
		cip = CryptoInformationProvider.getInstance();
		super.setUp();
	}

	protected void tearDown() throws Exception {
		cip = null;
		super.tearDown();
	}

}
